/* The mouse.h header file descibes the MOUSE interface. */

#ifndef _MOUSE_H
#define _MOUSE_H

/* The generic MOUSE interface structure. */
struct mouse {
  short buttons;		/* mouse button statii			*/
  short xpos, ypos;		/* mouse X and Y positions, absolute	*/
  short	dx, dy;			/* mouse X and Y positions, relative	*/
};
#define	M_BUT_R		0x01	/* right mouse button			*/
#define M_BUT_L		0x04	/* left mouse button			*/
#define M_ALLBUT	(M_BUT_R | M_BUT_L)

/* Various mouse controlling commands. */
#define MSIOCINIT	(('M'<<8) | 1)	/* (re-) initialize parameters	*/
#define MSIOCGCTRL	(('M'<<8) | 2)	/* get mouse parameters		*/
#define MSIOCSCTRL	(('M'<<8) | 3)	/* set mouse parameters		*/

/* The generic MOUSE control structure. */
struct mouse_ctrl {
  short xpos, ypos;		/* X and Y absolute positions		*/
  short xmickey, ymickey;	/* X and Y mickey-to-pixel ratios	*/
  short xmax, ymax;		/* X and Y screen display limits	*/
  short	cursor;			/* 1=cursor should be updated		*/
};

#endif	/* _MOUSE_H */
