/* readmouse.c -- /dev/mouse test program */

#include <stdio.h>
#include <sys/types.h>
#include <fcntl.h>
#include <errno.h>
#include <minix/mouse.h>

extern int ioctl (/* int, int, void* */);

/*					 */
/* define this to test non blocking mode */
/*					 */
#undef USE_NON_BLOCKING_MODE

int
main()
{
  int fd;
  struct mouse buf;
  struct mouse_ctrl msctl;
  int n;

  fd = open("/dev/mouse", O_RDONLY);
  if (fd < 0)
  {
    perror("open:/dev/mouse");
    return 1;
  }

#ifdef USE_NON_BLOCKING_MODE
  n = fcntl(fd, F_SETFL, O_NONBLOCK);
  if (n < 0)
  {
    perror("fcntl");
    return 1;
  }
#endif

  if (ioctl(fd, MSIOCINIT, (void*)0) < 0)
  {
    perror("MIOCINIT");
    return 1;
  }

  msctl.xpos = 0; msctl.ypos = 0;
  msctl.xmickey = 1; msctl.ymickey = 1;
  msctl.xmax = 200; msctl.ymax = 200;
  msctl.cursor = 0;
  if (ioctl(fd, MSIOCSCTRL, (void*)&msctl) < 0)
  {
    perror("MSIOCSCTRL");
    return 1;
  }

  while (1)
  {
    n = read(fd, &buf, sizeof(struct mouse));
    printf("read %d bytes\n", n);
    if (n > 0)
    {
      printf("(%d,%d)<%d,%d>%0.2x\n",
	buf.xpos, buf.ypos, buf.dx, buf.dy, buf.buttons);
    }
  }
  close(fd);
  return 0;
}
